#ifndef _domain_
#define _domain_


#include <fstream>
#include "out_latex.h"
#include <map>
#include <interval/interval.hpp>


using namespace std; 
typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;

class domain : public std::map <string, interval>
{
 public:

  int dimension();
  int topological_dimension();

  domain inflate(double eps);

  domain operator+(domain v);
  domain operator-(domain v);

  domain operator*(interval a);
  domain operator*(double a);
  domain hull(domain v);
  domain center();
  domain intersect(domain v);


  domain direct_sum(domain v);
  bool subset(domain v);
  void out();
  void latex(out_latex, string  );


  bool disjoint( domain );


  // return the corner of a domain
  domain corner ( map <string, bool>  boolean_vector );
  domain corner ( int i );

  double width();

  vector <domain> boundary();
  vector <domain> visibility(int j);

  vector <string> variables();


};


#endif
 
