#ifndef __THOM__
#define __THOM__

//---------------------------------------------------------------------------
#include <vector>
#include "expression.h"
#include "domain.h"
#include "iboolean.h"
#include "resultat.h"
#include "mesh.h"
#include "map.h"
#include "newton.h"
#include "vector_field.h"
#include "connexe.h"



class thom
{
 private :
  Map f;
  expression_matrix df;

  expression_matrix gradient;
  newton newton_singular_singular;
  
  expression det_differentielle;

  domain initial;


public: 

  Map Singular_curve;
  
  expression determina;
  thom(expression f1, expression f2, mesh m);
  
  domain evalue(domain);
  iboolean one_to_one(domain);

  void image();
  void relation();
  void relation2();

  bool relation3();
  bool relation4();


  void one_to_one();
  //  void one_to_one2();


  // contient les résultats des calculs
  resultat res;

  vector < vector < int > > graphe (vector <int > in);
  vector < vector  < int > > composantes_connexes (vector < int >);
  vector < vector  < int > > fr_composantes_connexes (int);

  //  bool test_newton(domain , domain);
  // bool newton_index_cc (int index, int cc_j);
  //  vector < bool > newton_index (int index );
  Map xi;

  // 
  void courbe_singuliere(double epsilon);


  // Cas numero 1 de l'article 
  Map cusp;
  newton newton_cusp;  
  int Cusp(domain X);
  bool one_to_one_cusp(domain x, bool);
  Map third_derivative;
  Map one_cusp;
  void improve_cusp();

  // Cas numero 2 de l'article
  //  void singular_curve(mesh m);
  bool one_to_one_singular(domain x);
  int singular_singular(domain, domain);
  void singular_singular(domain, bool );
  void improve_singular_singular();

  // Cas numero 3 de l'article
  void boundary_boundary(domain , bool);
  int boundary_boundary(domain, domain, bool);
  bool one_to_one_boundary(domain boundary);
  bool one_to_one_boundary(domain boundary1, domain boundary2 );
  pair <domain , domain > improve_boundary_boundary(pair <domain , domain>  Bi);
  void improve_boundary_boundary();

  // Cas numero 4 (et peut être 5) de l'article
  int singular_boundary(domain singular ,  domain boundary, bool verbose  );
  int singular_boundary(domain initial , bool verbose  );
  bool one_to_one_singular_boundary(domain singular , domain boundary  , bool verbose);
  void improve_singular_boundary();


  // Méthodes générales
  bool critical_points(domain X);


  bool remove_critical_points();

 
  /*  expression d1f1; 
  expression d2f1; 
  
  expression d1f2; 
  expression d2f2;  */
  
};




//---------------------------------------------------------------------------
#endif

